from abaqusGui import *
from kernelAccess import session, mdb
from plottingUtils import plot
import os

thisPath = os.path.abspath(__file__)
thisDir = os.path.dirname(thisPath)
fileName = os.path.join(os.path.split(__file__)[0],'superElasticPlasticIcon.png')
fileName2 = os.path.join(os.path.split(__file__)[0],'tipSmall.png')
superElasticIcon = afxCreatePNGIcon(fileName)
tip1 = afxCreatePNGIcon(fileName2)
###########################################################################
# Class definition
###########################################################################

class NitinolSuperelasticPlasticBehaviorDB( MCBehaviorEditDB ):
    [
    ID_TIP_BTN,
    ID_RB1,
    ID_RB2,
    ID_RB3,
    ID_RB4,
    ID_RB5,
    ID_RB6,
    ID_RB7,
    ID_RB8,
    ID_RB9,
    ID_RB10,
    ID_PERFORM_EVAL,
    ID_REFRESH,
    ID_REFRESH1
    ] = range(MCBehaviorEditDB.ID_LAST,MCBehaviorEditDB.ID_LAST+14)

    #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    def createContents( self ):
       
    
        modelName = self.form.modelName
        calibrationName = self.form.calibrationName
        calibration = mdb.models[ modelName ].calibrations[ calibrationName ]

        self.tipDB = None
        self.tipDB1 = None

        GroupBox_1 = FXGroupBox(p=self, text='Nitinol Material Parameters', opts=FRAME_GROOVE|LAYOUT_FILL_X)

        
        FXMAPFUNC(self, SEL_COMMAND, self.ID_TIP_BTN,NitinolSuperelasticPlasticBehaviorDB.onCmdTip)
        FXMAPFUNC(self, SEL_COMMAND, self.ID_PERFORM_EVAL, NitinolSuperelasticPlasticBehaviorDB.onCmdMatEval)
        FXMAPFUNC(self, SEL_COMMAND, self.ID_REFRESH, NitinolSuperelasticPlasticBehaviorDB.onCmdRefresh)  
        FXMAPFUNC(self, SEL_COMMAND, self.ID_REFRESH1, NitinolSuperelasticPlasticBehaviorDB.onCmdPlastRefresh)
        
        
        FXMAPFUNC(self, SEL_COMMAND, self.ID_RB3, NitinolSuperelasticPlasticBehaviorDB.onRadioClick1)
        FXMAPFUNC(self, SEL_COMMAND, self.ID_RB4, NitinolSuperelasticPlasticBehaviorDB.onRadioClick1)
        FXMAPFUNC(self, SEL_COMMAND, self.ID_RB5, NitinolSuperelasticPlasticBehaviorDB.onRadioClick1)
        
        
        FXMAPFUNC(self, SEL_COMMAND, self.ID_RB6, NitinolSuperelasticPlasticBehaviorDB.onRadioClick2)
        FXMAPFUNC(self, SEL_COMMAND, self.ID_RB7, NitinolSuperelasticPlasticBehaviorDB.onRadioClick2)
        
        FXMAPFUNC(self, SEL_COMMAND, self.ID_RB8, NitinolSuperelasticPlasticBehaviorDB.onRadioClick3)
        FXMAPFUNC(self, SEL_COMMAND, self.ID_RB9, NitinolSuperelasticPlasticBehaviorDB.onRadioClick3)
        FXMAPFUNC(self, SEL_COMMAND, self.ID_RB10, NitinolSuperelasticPlasticBehaviorDB.onRadioClick3)

        
        self.dataSetCombo = AFXComboBox(p=GroupBox_1, ncols=10, nvis=1, text='Data set:', 
                        tgt=self.form.ds1NameKw, sel=0)
                              
        self.dataSetCombo.setMaxVisible(10)
        
        tabBook = FXTabBook(p=GroupBox_1, tgt=None, sel=0, opts=LAYOUT_FILL_X)
        
        #For the Points tab
        #
        superelasticPlasticTab = FXTabItem(p=tabBook, text='Points')
        tab1Frame = FXVerticalFrame(tabBook,FRAME_RAISED)
        GroupBox_2 = FXGroupBox(p=tab1Frame, text='Pick/Enter Points', opts=FRAME_GROOVE|LAYOUT_FILL_X|LAYOUT_FILL_Y)
        icon = afxCreatePNGIcon(thisDir+r'/tipSmall.png')
        w=FXButton(p=GroupBox_2, text='\tShow Tip', ic=icon, tgt=self, sel=self.ID_TIP_BTN,opts=BUTTON_TOOLBAR | FRAME_RAISED|LAYOUT_RIGHT)  
       
         
        #For Point 1
        #
	hframe1= FXHorizontalFrame(p=GroupBox_2, opts=0, x=0, y=0, w=0, h=0,
			pl=0, pr=0, pt=0, pb=0)
	verFrame1 = FXVerticalFrame(p=hframe1, opts=0, x=0, y=0, w=0, h=0,
			pl=0, pr=0, pt=0, pb=0) 

	self.hframe17=FXHorizontalFrame(p=GroupBox_2, opts=0, x=0, y=0, w=0, h=0,
			pl=0, pr=0, pt=0, pb=0)            
	hframe1_1= FXHorizontalFrame(p=verFrame1, opts=0, x=0, y=0, w=0, h=0,
			pl=0, pr=0, pt=0, pb=0)
	self.lb1=FXLabel(p=hframe1_1, text='(1) Start of transformation during loading   ', ic=None, opts=LAYOUT_CENTER_Y|JUSTIFY_LEFT)
        icon = afxCreatePNGIcon(thisDir+r'/selectIcon.png')
	tipText1='\tPick Point1 in the viewport'
	self.pt1PickBtn = FXButton(p=hframe1_1, text=tipText1,ic=icon, tgt=self.form.tgtPt1, sel=AFXMode.ID_ACTIVATE, 
	opts=BUTTON_TOOLBAR | FRAME_RAISED | LAYOUT_CENTER_Y)
	self.Tf1=AFXTextField(p=hframe1_1, ncols=10, labelText='X', tgt=self.form.xPt1Kw, sel=0)
	self.Tf2=AFXTextField(p=hframe1_1, ncols=10, labelText='Y', tgt=self.form.YPt1Kw, sel=0)
        self.refreshBtn = FXButton(p=hframe1_1, text='Update viewport', tgt=self, sel=self.ID_REFRESH, 
        opts=BUTTON_TOOLBAR | FRAME_RAISED | LAYOUT_CENTER_Y) 
	


	#For Point 2
	#
	hframe3= FXHorizontalFrame(p=verFrame1, opts=0, x=0, y=0, w=0, h=0,
			pl=0, pr=0, pt=0, pb=0)        
	self.lb2=FXLabel(p=hframe3, text='(2) End of transformation during loading     ', ic=None, opts=LAYOUT_CENTER_Y|JUSTIFY_LEFT)        
        icon = afxCreatePNGIcon(thisDir+r'/selectIcon.png')
	tipText2='\tPick Point2 in the viewport'
	self.pt2PickBtn = FXButton(p=hframe3, text=tipText2,ic=icon, tgt=self.form.tgtPt2, sel=AFXMode.ID_ACTIVATE, 
		opts=BUTTON_TOOLBAR | FRAME_RAISED | LAYOUT_CENTER_Y)  

	self.Tf3=AFXTextField(p=hframe3, ncols=10, labelText='X', tgt=self.form.xPt2Kw, sel=0)
	self.Tf4=AFXTextField(p=hframe3, ncols=10, labelText='Y', tgt=self.form.YPt2Kw, sel=0)
        self.refreshBtn = FXButton(p=hframe3, text='Update viewport', tgt=self, sel=self.ID_REFRESH, 
        opts=BUTTON_TOOLBAR | FRAME_RAISED | LAYOUT_CENTER_Y) 
	
	#For Point 3
	#
	hframe5= FXHorizontalFrame(p=verFrame1, opts=0, x=0, y=0, w=0, h=0,
			pl=0, pr=0, pt=0, pb=0)        
	self.spaces=31*' '
	self.lb3=FXLabel(p=hframe5, text='(3) A point in Martensite'+self.spaces, ic=None, opts=LAYOUT_CENTER_Y|JUSTIFY_LEFT)        
        icon = afxCreatePNGIcon(thisDir+r'/selectIcon.png')
	tipText3='\tPick Point3 in the viewport'
	self.pt3PickBtn = FXButton(p=hframe5, text=tipText3,ic=icon, tgt=self.form.tgtPt3, sel=AFXMode.ID_ACTIVATE, 
	opts=BUTTON_TOOLBAR | FRAME_RAISED | LAYOUT_CENTER_Y) 

	self.Tf5=AFXTextField(p=hframe5, ncols=10, labelText='X', tgt=self.form.xPt3Kw, sel=0)
	self.Tf6=AFXTextField(p=hframe5, ncols=10, labelText='Y', tgt=self.form.YPt3Kw, sel=0)
        self.refreshBtn = FXButton(p=hframe5, text='Update viewport', tgt=self, sel=self.ID_REFRESH, 
        opts=BUTTON_TOOLBAR | FRAME_RAISED | LAYOUT_CENTER_Y)  
	

	#For Point 4
	#
	hframe7= FXHorizontalFrame(p=verFrame1, opts=0, x=0, y=0, w=0, h=0,
			pl=0, pr=0, pt=0, pb=0)        
	self.lb4=FXLabel(p=hframe7, text='(4) Start of transformation during unloading', ic=None, opts=LAYOUT_CENTER_Y|JUSTIFY_LEFT)        
        tipText4='\tPick Point4 in the viewport'
	icon = afxCreatePNGIcon(thisDir+r'/selectIcon.png')
	self.pt4PickBtn = FXButton(p=hframe7, text=tipText4,ic=icon, tgt=self.form.tgtPt4, sel=AFXMode.ID_ACTIVATE, 
	opts=BUTTON_TOOLBAR | FRAME_RAISED | LAYOUT_CENTER_Y)      
	self.Tf7=AFXTextField(p=hframe7, ncols=10, labelText='X', tgt=self.form.xPt4Kw, sel=0)
	self.Tf8=AFXTextField(p=hframe7, ncols=10, labelText='Y', tgt=self.form.YPt4Kw, sel=0)
        self.refreshBtn = FXButton(p=hframe7, text='Update viewport', tgt=self, sel=self.ID_REFRESH, 
        opts=BUTTON_TOOLBAR | FRAME_RAISED | LAYOUT_CENTER_Y) 	                           
	

	#For Point 5
	#
	hframe9= FXHorizontalFrame(p=verFrame1, opts=0, x=0, y=0, w=0, h=0,
			pl=0, pr=0, pt=0, pb=0)        
	self.lb4=FXLabel(p=hframe9, text='(5) End of transformation during unloading  ', ic=None, opts=LAYOUT_CENTER_Y|JUSTIFY_LEFT)        
        tipText5='\tPick Point5 in the viewport'
	icon = afxCreatePNGIcon(thisDir+r'/selectIcon.png')
	self.pt5PickBtn = FXButton(p=hframe9, text=tipText5,ic=icon, tgt=self.form.tgtPt5, sel=AFXMode.ID_ACTIVATE, 
	opts=BUTTON_TOOLBAR | FRAME_RAISED | LAYOUT_CENTER_Y)
	self.Tf9=AFXTextField(p=hframe9, ncols=10, labelText='X', tgt=self.form.xPt5Kw, sel=0)
	self.Tf10=AFXTextField(p=hframe9, ncols=10, labelText='Y', tgt=self.form.YPt5Kw, sel=0)
	self.refreshBtn = FXButton(p=hframe9, text='Update viewport', tgt=self, sel=self.ID_REFRESH, 
        opts=BUTTON_TOOLBAR | FRAME_RAISED | LAYOUT_CENTER_Y)                            

        
        #For plastic point picking
        #
        self.elasticPlasticP1HF5 = FXHorizontalFrame(p=GroupBox_2, opts=LAYOUT_FILL_X, x=0, y=0, w=0, h=0,pl=0, pr=0, pt=0, pb=0)
        self.elasticPlasticP1PlasticPtsLBL = FXLabel(p=self.elasticPlasticP1HF5, text='Plastic points:', ic=None, opts=LAYOUT_CENTER_Y )

        icon = afxCreatePNGIcon(thisDir+r'/selectIcon.png')                                             
        self.elasticPlasticP11PickPlasticBTN = FXButton(p=self.elasticPlasticP1HF5, 
                                                       text='\tPick the Plastic Point\nin the Viewport', 
                                                       ic=icon,
                                                       tgt=self.form.tgtPPP,
                                                       sel=AFXMode.ID_ACTIVATE,
                                                       opts=BUTTON_TOOLBAR | FRAME_RAISED | LAYOUT_CENTER_Y)
        self.lb4=FXLabel(p=self.elasticPlasticP1HF5, text='(only for superelastic plastic behavior)', ic=None, opts=LAYOUT_CENTER_Y|JUSTIFY_LEFT)
        self.refreshBtn = FXButton(p=self.elasticPlasticP1HF5,text='Update viewport', tgt=self, sel=self.ID_REFRESH1, 
        opts=BUTTON_TOOLBAR | FRAME_RAISED | LAYOUT_CENTER_Y) 
        
        # Table for plastic points
        #
        self.elasticPlasticP1VF1 = FXVerticalFrame(GroupBox_2, FRAME_SUNKEN|FRAME_THICK|LAYOUT_FILL_X,0,0,0,0, 0,0,0,0)
        self.elasticPlasticP1Table = AFXTable(self.elasticPlasticP1VF1, 5, 2, 5, 2, self.form.plasticPointsKw, 0, AFXTABLE_EDITABLE|AFXTABLE_COLUMN_RESIZABLE|AFXTABLE_NORMAL|LAYOUT_FILL_X)

        self.elasticPlasticP1Table.setLeadingRows(1)
        self.elasticPlasticP1Table.setLeadingRowLabels('Strain\tStress')
        self.elasticPlasticP1Table.setStretchableColumn( self.elasticPlasticP1Table.getNumColumns()-1)
        self.elasticPlasticP1Table.showHorizontalGrid(True)
        self.elasticPlasticP1Table.showVerticalGrid(True)
        self.elasticPlasticP1Table.setPopupOptions(
            AFXTable.POPUP_CUT|AFXTable.POPUP_COPY
           |AFXTable.POPUP_PASTE
           |AFXTable.POPUP_INSERT_ROW
           |AFXTable.POPUP_DELETE_ROW
           |AFXTable.POPUP_CLEAR_CONTENTS
           |AFXTable.POPUP_READ_FROM_FILE
        )

        hframe10= FXHorizontalFrame(p=GroupBox_2, opts=0, x=0, y=0, w=0, h=0,
                    pl=0, pr=0, pt=0, pb=0)
                
        #Check button for one element model submission for the calibrated material evaluation
        #
        self.chkBtn = FXCheckButton(hframe10, 'Perform material evaluation with one element model',  self, self.ID_PERFORM_EVAL)
        self.chkBtn.setCheck(FALSE)  
        
        message = 'Some positive slope for the transformation zone will help the convergence.'
        AFXNote(self.hframe17, message, opts=NOTE_INFORMATION, x=0, y=0)  
        
        #For the 'Data tab'
        #
        dataTab = FXTabItem(p=tabBook, text='Data')
        self.tab2Frame = FXVerticalFrame(tabBook,FRAME_RAISED)
        
        self.gb1 = FXGroupBox(p=self.tab2Frame, text='Analysis Type', opts=FRAME_GROOVE|LAYOUT_FILL_X)
  
        self.anaHframe6=FXHorizontalFrame(p=self.gb1, opts=0, x=0, y=0, w=0, h=0,
            pl=0, pr=0, pt=0, pb=0)
        self.sw = FXSwitcher(self.gb1)
        
        self.rb1=FXRadioButton(self.anaHframe6, 'Abaqus/Standard', self.sw, FXSwitcher.ID_OPEN_FIRST)
        self.rb2=FXRadioButton(self.anaHframe6, 'Abaqus/Explicit', self.sw, FXSwitcher.ID_OPEN_FIRST+1)
        self.vframe2 = FXVerticalFrame(p=self.sw, opts=0, x=0, y=0, w=0, h=0,
                    pl=0, pr=0, pt=0, pb=0)
        text1='Number of annealings to be performed'
        self.tf1=AFXTextField(p=self.vframe2, ncols=5, labelText=text1, tgt=self.form.nAnnealsKw, sel=0)
        text2='Annealing step numbers seperated by comma'
        self.tf2=AFXTextField(p=self.vframe2, ncols=5, labelText=text2, tgt=self.form.nStepsKw, sel=0)
        self.explHf=FXHorizontalFrame(p=self.sw, opts=0, x=0, y=0, w=0, h=0, pl=0, pr=0, pt=0, pb=0)
        self.blankLb=FXLabel(p=self.explHf, text='  ', ic=None, opts=LAYOUT_CENTER_Y|JUSTIFY_LEFT)        
        self.rb8=FXRadioButton(self.explHf, '1D', self, self.ID_RB8)
        self.rb9=FXRadioButton(self.explHf, '2D', self, self.ID_RB9)
        self.rb10=FXRadioButton(self.explHf, '3D', self, self.ID_RB10)
        self.rb10.setCheck(TRUE)
        self.denstf=AFXTextField(p=self.explHf, ncols=10, labelText="Material Density", tgt=self.form.densKw, sel=0)



        #Mechanical constants
        #
        self.gb2 = FXGroupBox(p=self.tab2Frame, text='Mechanical Constants', opts=FRAME_GROOVE|LAYOUT_FILL_X)
        self.hframe3=FXHorizontalFrame(p=self.gb2, opts=0, x=0, y=0, w=0, h=0,
            pl=0, pr=0, pt=0, pb=0)
        self.tf3=AFXTextField(p=self.hframe3, ncols=5, labelText="Austenite Poisson's ratio", tgt=self.form.aPoisKw, sel=0)
        self.tf4=AFXTextField(p=self.hframe3, ncols=5, labelText="Martensite Poisson's ratio", tgt=self.form.mPoisKw, sel=0)
        self.tf5=AFXTextField(p=self.hframe3, ncols=5, labelText="Reference temperature", tgt=self.form.rTempKw, sel=0)
        self.hframe4=FXHorizontalFrame(p=self.gb2, opts=0, x=0, y=0, w=0, h=0,
            pl=0, pr=0, pt=0, pb=0)
        self.tf5=AFXTextField(p=self.hframe4, ncols=5, labelText="Stress/Temperature gradient (Loading)", tgt=self.form.tGradLKw, sel=0)
        self.tf6=AFXTextField(p=self.hframe4, ncols=5, labelText="Stress/Temperature gradient (UnLoading)", tgt=self.form.tGradUKw, sel=0)
        self.vframe4=FXVerticalFrame(p=self.gb2, opts=0, x=0, y=0, w=0, h=0,
            pl=0, pr=0, pt=0, pb=0)
        txtLb5="Start of transformation stress in compression (Loading)"            
        self.lb5=FXLabel(p=self.vframe4, text=txtLb5, ic=None, opts=LAYOUT_CENTER_Y|JUSTIFY_LEFT)  
        self.hframe5=FXHorizontalFrame(p=self.vframe4, opts=0, x=0, y=0, w=0, h=0,
            pl=0, pr=0, pt=0, pb=0)

        self.rb3=FXRadioButton(self.hframe5, '',self, self.ID_RB3)
        
        self.tf7=AFXTextField(p=self.hframe5, ncols=5, labelText="Enter value", tgt=self.form.sigSClKw, sel=0)
        afxDisableWidgetTree(self.tf7)
        
        self.rb4=FXRadioButton(self.hframe5, 'Same as in tension',self, self.ID_RB4)
        self.rb4.setCheck(TRUE)

        self.rb5=FXRadioButton(self.hframe5, '1.25 times as in tension',self, self.ID_RB5)
        self.vframe5=FXVerticalFrame(p=self.gb2, opts=0, x=0, y=0, w=0, h=0,
            pl=0, pr=0, pt=0, pb=0)
        txtLb6="Volumetric transformation strain"            
        self.lb6=FXLabel(p=self.vframe4, text=txtLb6, ic=None, opts=LAYOUT_CENTER_Y|JUSTIFY_LEFT)
        self.hframe6=FXHorizontalFrame(p=self.vframe5, opts=0, x=0, y=0, w=0, h=0,
            pl=0, pr=0, pt=0, pb=0)

        self.rb6=FXRadioButton(self.hframe6, '',self, self.ID_RB6)
        self.rb6.setCheck(TRUE)
        self.tf8=AFXTextField(p=self.hframe6, ncols=5, labelText="Enter value", tgt=self.form.elKw, sel=0)

        self.rb7=FXRadioButton(self.hframe6, 'Same as uniaxial transformation strain',self, self.ID_RB7)
   
    #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    #Function to plot the points in the viewport with different symbols
    #
    def plotPickedPoint(self, Point1=None,Point2=None, Point3=None, Point4=None, Point5=None, plasticPoints=None):

        modelName = self.form.modelName
        calibrationName = self.form.calibrationName
        dsName = self.form.ds1NameKw.getValue()

        data={}
        if Point1 and Point2 and Point3 and Point4 and Point5:
            data[Point1], data[Point2], data[Point3], data[Point4], data[Point5]= ("-pt1","FILLED_CIRCLE"),\
            ("-pt2", "FILLED_SQUARE"), ("-pt3", "FILLED_TRI"), ("-pt4", "HOLLOW_SQUARE"), ("-pt5", "HOLLOW_CIRCLE")
            for Point in (Point1, Point2, Point3, Point4, Point5):                            
                plot(data=(Point,), xyName=dsName+data[Point][0], display=data[Point][1], plotName=dsName, append=True, color = 'Blue') 
        
        if Point1: 
           Point=Point1
           num="-pt1"
           mrkr="FILLED_CIRCLE"
        elif Point2: 
           Point=Point2
           num="-pt2"
           mrkr="FILLED_SQUARE"
        elif Point3: 
           Point=Point3
           num="-pt3"
           mrkr="FILLED_TRI"
        elif Point4: 
           Point=Point4
           num="-pt4"
           mrkr="HOLLOW_SQUARE"
        elif Point5:
           Point=Point5
           num="-pt5"
           mrkr="HOLLOW_CIRCLE"
        else:
           Point=''

        if mdb.models[ modelName ].calibrations[ calibrationName ].dataSets.has_key( dsName ):
           if plasticPoints:

               plot(data=plasticPoints, xyName=dsName+"-PlasticPt", display="HOLLOW_CIRCLE", plotName=dsName, append=True, color = 'Brown')

           if Point:
              plot(data=(Point,), xyName=dsName+num, display=mrkr, plotName=dsName, append=True, color = 'Blue')
        else:
           showAFXErrorDialog( self, 'Dataset %r does not exist.' % dsName) 

        return 1   
   #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   #Function to update the viewport when stress strain values are changed
   #from the text fields
   #
    def onCmdRefresh(self, sender, sel, ptr):
        try: 
            numRows=self.elasticPlasticP1Table.getNumRows()
            pt1=(self.form.xPt1Kw.getValue(),self.form.YPt1Kw.getValue())
            pt2=(self.form.xPt2Kw.getValue(),self.form.YPt2Kw.getValue())
            pt3=(self.form.xPt3Kw.getValue(),self.form.YPt3Kw.getValue())
            pt4=(self.form.xPt4Kw.getValue(),self.form.YPt4Kw.getValue())
            pt5=(self.form.xPt5Kw.getValue(),self.form.YPt5Kw.getValue())
            self.plotPickedPoint(Point1=pt1, Point2=pt2, Point3=pt3, Point4=pt4, Point5=pt5)
            
        except:
            showAFXErrorDialog( self, "Plot cannot be updated in the current viewort\n" )
 #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   #Function to update the viewport when stress strain values are changed
   #from the cells of the plastic points table using 'Update viewport button'
   #
    def onCmdPlastRefresh(self, sender, sel, ptr):
        try: 
            numRows=self.elasticPlasticP1Table.getNumRows()
            numColumns=self.elasticPlasticP1Table.getNumColumns()
    
            tableData = []
            for i in range(1, numRows):
                x=self.elasticPlasticP1Table.getItemValue(i,0)
                y=self.elasticPlasticP1Table.getItemValue(i,1)
                tableData.append((float(x),float(y)))
      
            self.plotPickedPoint(plasticPoints=tableData)
        except:
            showAFXErrorDialog( self, "Plot cannot be updated in the current viewort\n" )
            
   #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    def show( self ):
        modelName = self.form.modelName
        calibrationName = self.form.calibrationName
        behaviorName = self.form.behaviorName
        behavior = mdb.models[ modelName ].calibrations[ calibrationName ].behaviors[ behaviorName ]                
        mdb.models[ modelName ].calibrations[ calibrationName ].registerQuery( self.updateDataSets )
        MCBehaviorEditDB.show( self )
        #plot the behavior when showing the dialog
        #
        dsName = behavior.ds1Name
        if dsName:
            dsObj = mdb.models[modelName].calibrations[calibrationName].dataSets[dsName]
            plastPoints= behavior.plasticPoints
            if plastPoints:
                self.plotPickedPoint(plasticPoints=behavior.plasticPoints)
            self.plotPickedPoint(Point1=(behavior.xPt1,behavior.yPt1),Point2=(behavior.xPt2,behavior.yPt2), 
            Point3=(behavior.xPt3,behavior.yPt3), Point4=(behavior.xPt4,behavior.yPt4), 
            Point5=(behavior.xPt5,behavior.yPt5), plasticPoints=plastPoints)
            if behavior.anaType == 'std':
                self.form.anaTypeKw.setValue('std')
            elif behavior.anaType == 'expl':
                self.form.anaTypeKw.setValue('expl')
                                       
    #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    def hide( self ):

        ds1Name = self.form.ds1NameKw.getValue()        
        modelName = self.form.modelName
        calibrationName = self.form.calibrationName
        mdb.models[ modelName ].calibrations[ calibrationName ].unregisterQuery( self.updateDataSets )
        
        for i in range(1,6): 
            del session.xyDataObjects[ds1Name+"-pt"+str(i)]
        
        del session.xyDataObjects[ds1Name+"-PlasticPt"]
        self.form.tgtPt1.deactivate(True)
        self.form.tgtPt2.deactivate(True)
        self.form.tgtPt3.deactivate(True)
        self.form.tgtPt4.deactivate(True)
        self.form.tgtPt5.deactivate(True)
        self.form.tgtPPP.deactivate(True)
        
        MCBehaviorEditDB.hide( self )    
    
    #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    def updateDataSets( self ):
        
        modelName = self.form.modelName

        calibrationName = self.form.calibrationName
        behaviorName = self.form.behaviorName
        keys = mdb.models[ modelName ].calibrations[ calibrationName ].dataSets.keys()
        keys.sort()

        # if ds1Name not in keys, then clear it from the keyword and the behavior
        #
        ds1Name = self.form.ds1NameKw.getValue()

        if not ds1Name in keys:

            self.form.ds1NameKw.setValue('')
            mdb.models[ modelName ].calibrations[ calibrationName ].behaviors[ behaviorName ].setValues(ds1Name='')
        self.dataSetCombo.clearItems()
        for key in keys:
            self.dataSetCombo.appendItem( key )        
   #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ 
    def processUpdates(self):
    
        if self.rb1.getCheck():
           self.form.anaTypeKw.setValue('std')
          
        elif self.rb2.getCheck():
            self.form.anaTypeKw.setValue('expl')
	
   #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    def onRadioClick(self, sender, sel, ptr):
        if SELID(sel) == self.ID_RB1:
            self.rb1.setCheck(TRUE)
            self.rb2.setCheck(FALSE)
            self.form.anaTypeKw.setValue('std')
            afxDisableWidgetTree(self.explHf)
            afxEnableWidgetTree(self.vframe2)
            
        elif SELID(sel) == self.ID_RB2:
            self.rb1.setCheck(FALSE)
            self.rb2.setCheck(TRUE)
            self.form.anaTypeKw.setValue('expl')
            afxEnableWidgetTree(self.explHf)
            afxDisableWidgetTree(self.vframe2)
    #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    def onRadioClick1(self, sender, sel, ptr):
        if SELID(sel) == self.ID_RB3:
            self.rb3.setCheck(TRUE)
            self.form.sigmaslKw.setValue('entersigmasl')
            afxEnableWidgetTree(self.tf7)
            self.rb4.setCheck(FALSE)
            self.rb5.setCheck(FALSE)
        elif SELID(sel) == self.ID_RB4:
            self.rb4.setCheck(TRUE)
            afxDisableWidgetTree(self.tf7)
            self.form.sigmaslKw.setValue('equalsigmasl')
            self.rb3.setCheck(FALSE)
            self.rb5.setCheck(FALSE)
        elif SELID(sel) == self.ID_RB5:
            self.rb5.setCheck(TRUE)
            afxDisableWidgetTree(self.tf7)
            self.form.sigmaslKw.setValue('timessigmasl')
            self.rb4.setCheck(FALSE)
            self.rb3.setCheck(FALSE)
            
	#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    def onRadioClick2(self, sender, sel, ptr):
        if SELID(sel) == self.ID_RB6:
            self.rb6.setCheck(TRUE)
            afxEnableWidgetTree(self.tf8)
            self.form.volStrainKw.setValue('enterVol')
            self.rb7.setCheck(FALSE)

        elif SELID(sel) == self.ID_RB7:
            self.rb7.setCheck(TRUE)
            self.form.volStrainKw.setValue('eqVol')
            afxDisableWidgetTree(self.tf8)
            self.rb6.setCheck(FALSE)
    #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~        
    def onRadioClick3(self, sender, sel, ptr):
        if SELID(sel) == self.ID_RB8:
            self.rb8.setCheck(TRUE)
            self.form.dimensionKw.setValue('1D')
            self.rb9.setCheck(FALSE)
            self.rb10.setCheck(FALSE)

        elif SELID(sel) == self.ID_RB9:
            self.rb9.setCheck(TRUE)
            self.form.dimensionKw.setValue('2D')
            self.rb8.setCheck(FALSE)
            self.rb10.setCheck(FALSE)

        elif SELID(sel) == self.ID_RB10:
            self.rb10.setCheck(TRUE)
            self.form.dimensionKw.setValue('3D')
            self.rb8.setCheck(FALSE)
            self.rb9.setCheck(FALSE)
	#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    def onCmdMatEval(self, sender, sel, ptr):
        if self.chkBtn.getCheck():

            self.form.eval1Kw.setValue(True)
        else:

            self.form.eval1Kw.setValue(False)
                    
    #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    def setPoint1FromXY(self, picked_point):
 
        # set the keyword in the form
        #
        self.form.xPt1Kw.setValue(str(picked_point[0]))
        self.form.YPt1Kw.setValue(str(picked_point[1]))        
        # set the text field to the keyword
        #
        self.setPoint1TFtoKw()  
        pt1=picked_point
        self.plotPickedPoint(Point1=pt1)
        # set pick button to unpushed
        #
        self.pt1PickBtn.setState(STATE_UP) 
    
    #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~        

    def setPoint1TFtoKw(self):
        
        self.Pt1Txt1 = self.form.xPt1Kw.getValueAsString()
        self.Pt1Txt2 = self.form.YPt1Kw.getValueAsString()
        self.Tf1.setText(self.Pt1Txt1)
        self.Tf2.setText(self.Pt1Txt2) 
    #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    def setPoint2FromXY(self, picked_point):

        # set the keyword in the form
        #
        self.form.xPt2Kw.setValue(str(picked_point[0]))
        self.form.YPt2Kw.setValue(str(picked_point[1]))        


        self.setPoint2TFtoKw()  
        pt2=picked_point
        self.plotPickedPoint(Point2=pt2)
        # set pick button to unpushed
        #
        self.pt2PickBtn.setState(STATE_UP)         
    #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~        

    def setPoint2TFtoKw(self):
        
        self.Pt2Txt1 = self.form.xPt2Kw.getValueAsString()
        self.Pt2Txt2 = self.form.YPt2Kw.getValueAsString()
        self.Tf3.setText(self.Pt2Txt1)
        self.Tf4.setText(self.Pt2Txt2)   
        
    #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    def setPoint3FromXY(self, picked_point):

        # set the keyword in the form
        #
        self.form.xPt3Kw.setValue(str(picked_point[0]))
        self.form.YPt3Kw.setValue(str(picked_point[1]))        

        self.setPoint3TFtoKw()  
        pt3=picked_point
        self.plotPickedPoint(Point3=pt3)
        # set pick button to unpushed
        #
        self.pt3PickBtn.setState(STATE_UP)         
    #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~        

    def setPoint3TFtoKw(self):
        
        self.Pt3Txt1 = self.form.xPt3Kw.getValueAsString()
        self.Pt3Txt2 = self.form.YPt3Kw.getValueAsString()
        self.Tf5.setText(self.Pt3Txt1)
        self.Tf6.setText(self.Pt3Txt2)
        
    #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    def setPoint4FromXY(self, picked_point):

        # set the keyword in the form
        #
        self.form.xPt4Kw.setValue(str(picked_point[0]))
        self.form.YPt4Kw.setValue(str(picked_point[1]))        


        self.setPoint4TFtoKw()  
        pt4=picked_point
        self.plotPickedPoint(Point4=pt4)
        # set pick button to unpushed
        #
        self.pt4PickBtn.setState(STATE_UP)         
    #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~        

    def setPoint4TFtoKw(self):
        
        self.Pt4Txt1 = self.form.xPt4Kw.getValueAsString()
        self.Pt4Txt2 = self.form.YPt4Kw.getValueAsString()
        self.Tf7.setText(self.Pt4Txt1)
        self.Tf8.setText(self.Pt4Txt2)
        
    #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    def setPoint5FromXY(self, picked_point):

        # set the keyword in the form
        #
        self.form.xPt5Kw.setValue(str(picked_point[0]))
        self.form.YPt5Kw.setValue(str(picked_point[1]))        

        self.setPoint5TFtoKw()  
        pt5=picked_point
        self.plotPickedPoint(Point5=pt5)
        # set pick button to unpushed
        #
        self.pt5PickBtn.setState(STATE_UP)         
    #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~        

    def setPoint5TFtoKw(self):
        
        self.Pt5Txt1 = self.form.xPt5Kw.getValueAsString()
        self.Pt5Txt2 = self.form.YPt5Kw.getValueAsString()
        self.Tf9.setText(self.Pt5Txt1)
        self.Tf10.setText(self.Pt5Txt2)
        
   #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    def onCmdTip(self, sender, sel, ptr):
        if not self.tipDB:
            self.tipDB = TipDB(self)
            self.tipDB.create()

        self.tipDB.show()

     
        
##########################################################################
# Class definition
###########################################################################

class TipDB(AFXDialog):
    
    #numInstance = 0
    #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    def __init__(self, dbOwner):

        #TipDB.numInstance += 1
        # Construct the base class.
        #
        AFXDialog.__init__(self, 'Superelasticplastic Behavior Tip',
            self.DISMISS, DIALOG_NORMAL|DIALOG_UNPOST_DESTROY|DECOR_RESIZE)

        icon = superElasticIcon
        self.label = FXLabel(self,'',icon)
        
